diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/test/wifi-txop-test.cc ns-3.45/src/wifi/test/wifi-txop-test.cc
--- ns-3.44/src/wifi/test/wifi-txop-test.cc	2025-03-09 16:55:49.815372700 -0700
+++ ns-3.45/src/wifi/test/wifi-txop-test.cc	2025-06-01 20:34:45.644702200 -0700
@@ -1084,18 +1189,18 @@
                           tEnd + sifs + tolerance,
                           ack << " in response to the first QoS data frame sent too late");
     NS_TEST_EXPECT_MSG_EQ(
-        (m_nonHt ? m_txPsdus[18].header.IsAck() : m_txPsdus[18].header.IsBlockAck()),
+        (m_nonHt ? m_txPsdus[16].header.IsAck() : m_txPsdus[16].header.IsBlockAck()),
         true,
         "Expected a " << ack);
-    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[18].header.GetAddr1(),
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[16].header.GetAddr1(),
                           apDev->GetMac()->GetAddress(),
                           "Expected a " << ack << " sent to the AP");
     NS_TEST_EXPECT_MSG_EQ(
-        m_txPsdus[18].header.GetDuration(),
-        RoundDurationId(m_txPsdus[17].header.GetDuration() - sifs - m_txPsdus[18].txDuration),
+        m_txPsdus[16].header.GetDuration(),
+        RoundDurationId(m_txPsdus[15].header.GetDuration() - sifs - m_txPsdus[16].txDuration),
         "Duration/ID of the " << ack << " must be derived from that of the previous frame");
 
-    std::size_t idx = 18;
+    std::size_t idx = 16;
 
     if (!m_singleRtsPerTxop)
     {
@@ -1111,10 +1216,17 @@
             m_txPsdus[idx].header.GetAddr1(),
             DynamicCast<WifiNetDevice>(m_staDevices.Get(1))->GetMac()->GetAddress(),
             "Expected an RTS frame sent by the AP to the second station");
-        NS_TEST_EXPECT_MSG_EQ(m_txPsdus[idx].header.GetDuration(),
-                              RoundDurationId(m_apTxopLimit - (m_txPsdus[idx].txStart - txopStart) -
-                                              m_txPsdus[idx].txDuration),
-                              "Duration/ID of the second RTS frame must cover the whole TXOP");
+        NS_TEST_EXPECT_MSG_EQ(
+            m_txPsdus[idx].header.GetDuration(),
+            (!m_protectSingleExchange
+                 ? RoundDurationId(m_apTxopLimit - (m_txPsdus[idx].txStart - txopStart) -
+                                   m_txPsdus[idx].txDuration)
+                 : sifs + m_txPsdus[idx + 1].txDuration + sifs + m_txPsdus[idx + 2].txDuration +
+                       sifs + m_txPsdus[idx + 3].txDuration + m_singleExchangeProtectionSurplus),
+            (!m_protectSingleExchange
+                 ? "Duration/ID of the second RTS frame must cover the whole TXOP"
+                 : "Duration/ID of the second RTS frame must be set to remaining time to complete "
+                   "CTS+DATA+(Block)ACK sequence"));
 
         // a CTS is sent by STA2 (which ignores the NAV)
         tEnd = m_txPsdus[idx].txStart + m_txPsdus[idx].txDuration;
@@ -1164,9 +1276,14 @@
     }
     NS_TEST_EXPECT_MSG_EQ(
         m_txPsdus[idx].header.GetDuration(),
-        RoundDurationId(m_apTxopLimit - (m_txPsdus[idx].txStart - txopStart) -
-                        m_txPsdus[idx].txDuration),
-        "Duration/ID of the second QoS data frame does not cover the remaining TXOP");
+        (!m_protectSingleExchange
+             ? RoundDurationId(m_apTxopLimit - (m_txPsdus[idx].txStart - txopStart) -
+                               m_txPsdus[idx].txDuration)
+             : sifs + m_txPsdus[idx + 1].txDuration + m_singleExchangeProtectionSurplus),
+        (!m_protectSingleExchange
+             ? "Duration/ID of the second QoS data frame does not cover the remaining TXOP"
+             : "Duration/ID of the second QoS data frame must be set to remaining time to "
+               "complete DATA+(Block)ACK sequence"));
 
     // a Normal/Block Ack is then sent by STA2
     tEnd = m_txPsdus[idx].txStart + m_txPsdus[idx].txDuration;
@@ -1205,10 +1322,17 @@
             m_txPsdus[idx].header.GetAddr1(),
             DynamicCast<WifiNetDevice>(m_staDevices.Get(2))->GetMac()->GetAddress(),
             "Expected an RTS frame sent by the AP to the third station");
-        NS_TEST_EXPECT_MSG_EQ(m_txPsdus[idx].header.GetDuration(),
-                              RoundDurationId(m_apTxopLimit - (m_txPsdus[idx].txStart - txopStart) -
-                                              m_txPsdus[idx].txDuration),
-                              "Duration/ID of the third RTS frame must cover the whole TXOP");
+        NS_TEST_EXPECT_MSG_EQ(
+            m_txPsdus[idx].header.GetDuration(),
+            (!m_protectSingleExchange
+                 ? RoundDurationId(m_apTxopLimit - (m_txPsdus[idx].txStart - txopStart) -
+                                   m_txPsdus[idx].txDuration)
+                 : sifs + m_txPsdus[idx + 1].txDuration + sifs + m_txPsdus[idx + 2].txDuration +
+                       sifs + m_txPsdus[idx + 3].txDuration + m_singleExchangeProtectionSurplus),
+            (!m_protectSingleExchange
+                 ? "Duration/ID of the third RTS frame must cover the whole TXOP"
+                 : "Duration/ID of the third RTS frame must be set to remaining time to complete "
+                   "CTS+DATA+(Block)ACK sequence"));
 
         // a CTS is sent by STA3 (which ignores the NAV)
         tEnd = m_txPsdus[idx].txStart + m_txPsdus[idx].txDuration;
@@ -1257,9 +1381,14 @@
     }
     NS_TEST_EXPECT_MSG_EQ(
         m_txPsdus[idx].header.GetDuration(),
-        RoundDurationId(m_apTxopLimit - (m_txPsdus[idx].txStart - txopStart) -
-                        m_txPsdus[idx].txDuration),
-        "Duration/ID of the third QoS data frame does not cover the remaining TXOP");
+        (!m_protectSingleExchange
+             ? RoundDurationId(m_apTxopLimit - (m_txPsdus[idx].txStart - txopStart) -
+                               m_txPsdus[idx].txDuration)
+             : sifs + m_txPsdus[idx + 1].txDuration + m_singleExchangeProtectionSurplus),
+        (!m_protectSingleExchange
+             ? "Duration/ID of the third QoS data frame does not cover the remaining TXOP"
+             : "Duration/ID of the third QoS data frame must be set to remaining time to "
+               "complete DATA+(Block)ACK sequence"));
 
     // a Normal/Block Ack is then sent by STA3
     tEnd = m_txPsdus[idx].txStart + m_txPsdus[idx].txDuration;
@@ -1286,7 +1415,7 @@
 
     // there is no time remaining for sending a CF-End frame if SingleRtsPerTxop is false. This is
     // verified by checking that 25 frames are transmitted (done at the beginning of this method)
-    if (m_singleRtsPerTxop)
+    if (m_singleRtsPerTxop && !m_protectSingleExchange)
     {
         tEnd = m_txPsdus[idx].txStart + m_txPsdus[idx].txDuration;
         ++idx;
@@ -1296,7 +1425,7 @@
         NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "CF-End sent too late");
         NS_TEST_EXPECT_MSG_EQ(m_txPsdus[idx].header.IsCfEnd(), true, "Expected a CF-End frame");
         NS_TEST_EXPECT_MSG_EQ(m_txPsdus[idx].header.GetDuration(),
-                              Seconds(0),
+                              MicroSeconds(0),
                               "Duration/ID must be set to 0 for CF-End frames");
     }
 
@@ -1324,24 +1453,41 @@
 {
     for (const auto nonHt : {true, false})
     {
-        AddTestCase(new WifiTxopTest({.nonHt = nonHt,
-                                      .pifsRecovery = true,
-                                      .singleRtsPerTxop = false,
-                                      .lengthBasedRtsCtsThresh = false,
-                                      .protectedIfResponded = true}),
-                    TestCase::Duration::QUICK);
-        AddTestCase(new WifiTxopTest({.nonHt = nonHt,
-                                      .pifsRecovery = false,
-                                      .singleRtsPerTxop = true,
-                                      .lengthBasedRtsCtsThresh = false,
-                                      .protectedIfResponded = false}),
-                    TestCase::Duration::QUICK);
-        AddTestCase(new WifiTxopTest({.nonHt = nonHt,
-                                      .pifsRecovery = true,
-                                      .singleRtsPerTxop = true,
-                                      .lengthBasedRtsCtsThresh = true,
-                                      .protectedIfResponded = true}),
-                    TestCase::Duration::QUICK);
+        for (const auto pifsRecovery : {true, false})
+        {
+            for (const auto singleRtsPerTxop : {true, false})
+            {
+                for (const auto lengthBasedRtsCtsThresh : {true, false})
+                {
+                    for (const auto protectedIfResponded : {true, false})
+                    {
+                        for (const auto protectSingleExchange : {false, true})
+                        {
+                            for (const auto& singleExchangeProtectionBuffer :
+                                 {Time(), MicroSeconds(25) /* PIFS */})
+                            {
+                                if (!protectSingleExchange &&
+                                    singleExchangeProtectionBuffer.IsStrictlyPositive())
+                                {
+                                    continue;
+                                }
+                                AddTestCase(new WifiTxopTest({
+                                                .nonHt = nonHt,
+                                                .pifsRecovery = pifsRecovery,
+                                                .singleRtsPerTxop = singleRtsPerTxop,
+                                                .lengthBasedRtsCtsThresh = lengthBasedRtsCtsThresh,
+                                                .protectedIfResponded = protectedIfResponded,
+                                                .protectSingleExchange = protectSingleExchange,
+                                                .singleExchangeProtectionBuffer =
+                                                    singleExchangeProtectionBuffer,
+                                            }),
+                                            TestCase::Duration::QUICK);
+                            }
+                        }
+                    }
+                }
+            }
+        }
     }
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/test/wifi-tx-stats-helper-test.cc ns-3.45/src/wifi/test/wifi-tx-stats-helper-test.cc
--- ns-3.44/src/wifi/test/wifi-tx-stats-helper-test.cc	2025-03-09 16:55:49.815372700 -0700
+++ ns-3.45/src/wifi/test/wifi-tx-stats-helper-test.cc	2025-06-01 20:34:45.643702300 -0700
@@ -139,6 +139,7 @@
         m_durations[1].push_back(
             WifiPhy::CalculateTxDuration(psduMap, txVector, WIFI_PHY_BAND_6GHZ));
     }
+    NS_LOG_INFO("LINKID=" << +linkId << " " << *psduMap.cbegin()->second << "\n");
 }
 
 void
@@ -1158,9 +1159,9 @@
     // transmission times and packet durations observed at the PHY layer, to cross-check against
     // the times recorded in the WifiTxStatsHelper record (traced at the MAC layer).
     // The testcase also checks the various fields in this helper's output records for correctness.
-    AddTestCase(new WifiTxStatsHelperTest("Check single link non-QoS configuration",
-                                          WifiTxStatsHelperTest::SINGLE_LINK_NON_QOS),
-                TestCase::Duration::QUICK);
+    // AddTestCase(new WifiTxStatsHelperTest("Check single link non-QoS configuration",
+    //                                       WifiTxStatsHelperTest::SINGLE_LINK_NON_QOS),
+    //             TestCase::Duration::QUICK);
 
     // A test case to evaluate the transmission process of multiple Wi-Fi MAC Layer MPDUs in
     // a multi link device. This testcase, unlike the previous, uses .11be to test the
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wimax/model/bs-link-manager.cc ns-3.45/src/wimax/model/bs-link-manager.cc
--- ns-3.44/src/wimax/model/bs-link-manager.cc	2025-03-09 16:55:49.815372700 -0700
+++ ns-3.45/src/wimax/model/bs-link-manager.cc	2025-06-01 20:34:45.644702200 -0700
@@ -248,7 +248,8 @@
             {
                 auto rngrsp = new RngRsp();
                 AbortRanging(ssRecord->GetBasicCid(), rngrsp, ssRecord, true);
-            } // else keep polling
+            }
+            // else keep polling
         }
     }
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wimax/model/bs-uplink-scheduler-mbqos.cc ns-3.45/src/wimax/model/bs-uplink-scheduler-mbqos.cc
--- ns-3.44/src/wimax/model/bs-uplink-scheduler-mbqos.cc	2025-03-09 16:55:49.815372700 -0700
+++ ns-3.45/src/wimax/model/bs-uplink-scheduler-mbqos.cc	2025-06-01 20:34:45.645702400 -0700
@@ -898,8 +898,7 @@
         {
             NS_LOG_DEBUG("BS uplink scheduler, " << serviceFlow->GetSchedulingTypeStr()
                                                  << " unicast poll, size: " << allocationSize
-                                                 << " symbols"
-                                                 << ", modulation: BPSK 1/2");
+                                                 << " symbols, modulation: BPSK 1/2");
         }
 
         NS_LOG_DEBUG(", CID: " << serviceFlow->GetConnection()->GetCid()
@@ -1022,8 +1021,7 @@
         ulMapIeIr.SetUiuc(OfdmUlBurstProfile::UIUC_INITIAL_RANGING);
 
         NS_LOG_DEBUG("BS uplink scheduler, initial ranging allocation, size: "
-                     << allocationSize << " symbols"
-                     << ", modulation: BPSK 1/2");
+                     << allocationSize << " symbols, modulation: BPSK 1/2");
 
         // marking start and end of each TO, only for debugging
         for (uint8_t i = 0; i < GetNrIrOppsAllocated(); i++)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wimax/model/bs-uplink-scheduler-rtps.cc ns-3.45/src/wimax/model/bs-uplink-scheduler-rtps.cc
--- ns-3.44/src/wimax/model/bs-uplink-scheduler-rtps.cc	2025-03-09 16:55:49.815372700 -0700
+++ ns-3.45/src/wimax/model/bs-uplink-scheduler-rtps.cc	2025-06-01 20:34:45.645702400 -0700
@@ -421,8 +421,7 @@
         {
             NS_LOG_DEBUG("BS uplink scheduler, " << serviceFlow->GetSchedulingTypeStr()
                                                  << " unicast poll, size: " << allocationSize
-                                                 << " symbols"
-                                                 << ", modulation: BPSK 1/2");
+                                                 << " symbols, modulation: BPSK 1/2");
         }
 
         NS_LOG_DEBUG(", CID: " << serviceFlow->GetConnection()->GetCid()
@@ -646,8 +645,7 @@
         ulMapIeIr.SetUiuc(OfdmUlBurstProfile::UIUC_INITIAL_RANGING);
 
         NS_LOG_DEBUG("BS uplink scheduler, initial ranging allocation, size: "
-                     << allocationSize << " symbols"
-                     << ", modulation: BPSK 1/2");
+                     << allocationSize << " symbols, modulation: BPSK 1/2");
 
         // marking start and end of each TO, only for debugging
         for (uint8_t i = 0; i < GetNrIrOppsAllocated(); i++)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wimax/model/bs-uplink-scheduler-simple.cc ns-3.45/src/wimax/model/bs-uplink-scheduler-simple.cc
--- ns-3.44/src/wimax/model/bs-uplink-scheduler-simple.cc	2025-03-09 16:55:49.815372700 -0700
+++ ns-3.45/src/wimax/model/bs-uplink-scheduler-simple.cc	2025-06-01 20:34:45.646702300 -0700
@@ -495,8 +495,7 @@
         ulMapIeIr.SetUiuc(OfdmUlBurstProfile::UIUC_INITIAL_RANGING);
 
         NS_LOG_DEBUG("BS uplink scheduler, initial ranging allocation, size: "
-                     << allocationSize << " symbols"
-                     << ", modulation: BPSK 1/2");
+                     << allocationSize << " symbols, modulation: BPSK 1/2");
 
         // marking start and end of each TO, only for debugging
         for (uint8_t i = 0; i < GetNrIrOppsAllocated(); i++)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wimax/model/ss-net-device.cc ns-3.45/src/wimax/model/ss-net-device.cc
--- ns-3.44/src/wimax/model/ss-net-device.cc	2025-03-09 16:55:49.819372700 -0700
+++ ns-3.45/src/wimax/model/ss-net-device.cc	2025-06-01 20:34:45.648702400 -0700
@@ -782,15 +782,13 @@
         record->UpdatePktsSent(burst->GetNPackets());
         record->UpdateBytesSent(burst->GetSize());
 
-        NS_LOG_DEBUG(" sending burst"
-                     << ", SFID: " << connection->GetServiceFlow()->GetSfid() << ", pkts sent: "
-                     << record->GetPktsSent() << ", pkts rcvd: " << record->GetPktsRcvd()
-                     << ", bytes sent: " << record->GetBytesSent()
-                     << ", bytes rcvd: " << record->GetBytesRcvd());
-    }
-    else
-    {
+        NS_LOG_DEBUG(" sending burst, SFID: " << connection->GetServiceFlow()->GetSfid()
+                                              << ", pkts sent: " << record->GetPktsSent()
+                                              << ", pkts rcvd: " << record->GetPktsRcvd()
+                                              << ", bytes sent: " << record->GetBytesSent()
+                                              << ", bytes rcvd: " << record->GetBytesRcvd());
     }
+
     ForwardDown(burst, modulationType);
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/zigbee/model/zigbee-nwk.cc ns-3.45/src/zigbee/model/zigbee-nwk.cc
--- ns-3.44/src/zigbee/model/zigbee-nwk.cc	2025-03-09 16:55:49.823372800 -0700
+++ ns-3.45/src/zigbee/model/zigbee-nwk.cc	2025-06-01 20:34:45.651702400 -0700
@@ -2525,9 +2525,9 @@
         // Note: Scan duration is fixed to a macResponseWaitTime in an Orphan scan
         //       (i.e. It does not use the scanDuration parameter)
         scanParams.m_scanType = MLMESCAN_ORPHAN;
-        NS_LOG_DEBUG("Orphan scanning started, "
-                     << "sending orphan notifications on page " << page << " and channels "
-                     << std::hex << params.m_scanChannelList.channelsField[0]);
+        NS_LOG_DEBUG("Orphan scanning started, sending orphan notifications on page "
+                     << page << " and channels " << std::hex
+                     << params.m_scanChannelList.channelsField[0]);
 
         Simulator::ScheduleNow(&LrWpanMacBase::MlmeScanRequest, m_mac, scanParams);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/zigbee/model/zigbee-nwk-payload-header.cc ns-3.45/src/zigbee/model/zigbee-nwk-payload-header.cc
--- ns-3.44/src/zigbee/model/zigbee-nwk-payload-header.cc	2025-03-09 16:55:49.819372700 -0700
+++ ns-3.45/src/zigbee/model/zigbee-nwk-payload-header.cc	2025-06-01 20:34:45.651702400 -0700
@@ -372,10 +372,29 @@
 ZigbeePayloadRouteReplyCommand::Serialize(Buffer::Iterator start) const
 {
     Buffer::Iterator i = start;
+
+    uint8_t cmdOption = 0;
+    if (m_cmdOptOrigIeeeAddr)
+    {
+        cmdOption |= (1 << 4);
+    }
+
+    if (m_cmdOptRespIeeeAddr)
+    {
+        cmdOption |= (1 << 5);
+    }
+
+    if (m_cmdOptMcst)
+    {
+        cmdOption |= (1 << 6);
+    }
+    i.WriteU8(cmdOption);
+
     i.WriteU8(m_routeReqId);
     WriteTo(i, m_origAddr);
     WriteTo(i, m_respAddr);
     i.WriteU8(m_pathCost);
+
     if (m_cmdOptOrigIeeeAddr)
     {
         WriteTo(i, m_origIeeeAddr);
@@ -391,10 +410,17 @@
 ZigbeePayloadRouteReplyCommand::Deserialize(Buffer::Iterator start)
 {
     Buffer::Iterator i = start;
+
+    uint8_t cmdOption = i.ReadU8();
+    m_cmdOptOrigIeeeAddr = (cmdOption & (1 << 4)) != 0;
+    m_cmdOptRespIeeeAddr = (cmdOption & (1 << 5)) != 0;
+    m_cmdOptMcst = (cmdOption & (1 << 6)) != 0;
+
     m_routeReqId = (i.ReadU8());
     ReadFrom(i, m_origAddr);
     ReadFrom(i, m_respAddr);
     m_pathCost = (i.ReadU8());
+
     if (m_cmdOptOrigIeeeAddr)
     {
         ReadFrom(i, m_origIeeeAddr);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/zigbee/model/zigbee-nwk-tables.cc ns-3.45/src/zigbee/model/zigbee-nwk-tables.cc
--- ns-3.44/src/zigbee/model/zigbee-nwk-tables.cc	2025-03-09 16:55:49.819372700 -0700
+++ ns-3.45/src/zigbee/model/zigbee-nwk-tables.cc	2025-06-01 20:34:45.651702400 -0700
@@ -1087,32 +1087,45 @@
 bool
 NeighborTable::LookUpForBestParent(uint64_t epid, Ptr<NeighborTableEntry>& entryFound)
 {
-    bool flag = false;
+    bool parentFound = false;
     uint8_t currentLinkCost = 7;
     uint8_t prevLinkCost = 8;
-
+    bool first = true;
     for (const auto& entry : m_neighborTable)
     {
         // Note: Permit to join, stack profile , update id and capability are checked when
         //       the beacon is received (beacon notify indication)
         currentLinkCost = GetLinkCost(entry->GetLqi());
 
+        NS_LOG_DEBUG("Potential Parent: "
+                     << entry->GetNwkAddr() << " | LQI " << static_cast<uint16_t>(entry->GetLqi())
+                     << " | LinkCost " << static_cast<uint16_t>(currentLinkCost) << " | DevType "
+                     << entry->GetDeviceType());
+
+        // Select a parent device that fulfills at least these
+        // requirements, a minimum link cost of 3 is ideal but not enforced.
         if ((epid == entry->GetExtPanId()) &&
             (entry->GetDeviceType() == ZIGBEE_COORDINATOR ||
              entry->GetDeviceType() == ZIGBEE_ROUTER) &&
-            (entry->IsPotentialParent()) && (currentLinkCost <= 3))
+            entry->IsPotentialParent())
         {
-            if (currentLinkCost < prevLinkCost)
+            if (first)
+            {
+                first = false;
+                entryFound = entry;
+                prevLinkCost = currentLinkCost;
+                parentFound = true;
+            }
+            else if (currentLinkCost < prevLinkCost)
             {
                 entryFound = entry;
                 prevLinkCost = currentLinkCost;
             }
-            entryFound = entry;
-            flag = true;
         }
     }
 
-    return flag;
+    NS_LOG_DEBUG("Parent Chosen: " << entryFound->GetNwkAddr());
+    return parentFound;
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/test.py ns-3.45/test.py
--- ns-3.44/test.py	2025-03-09 16:55:49.823372800 -0700
+++ ns-3.45/test.py	2025-06-01 20:34:45.652702300 -0700
@@ -1994,11 +1994,17 @@
                 status = "CRASH"
                 status_print = colors.PINK + status + colors.NORMAL
 
-        print("[%d/%d]" % (i, total_tests), end=" ")
+        print("[%d/%d] %s" % (i, total_tests, status_print), end="")
+
         if args.duration or args.constrain == "performance":
-            print("%s (%.3f): %s %s" % (status_print, job.elapsed_time, kind, job.display_name))
-        else:
-            print("%s: %s %s" % (status_print, kind, job.display_name))
+            print(" (%.3f)" % job.elapsed_time, end="")
+
+        print(":", end="")
+
+        if "NS_COMMANDLINE_INTROSPECTION" in os.environ:
+            print(" Wrote example usage for", end="")
+
+        print(" %s %s" % (kind, job.display_name))
 
         if job.is_example or job.is_pyexample:
             #
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/utils/bench-scheduler.cc ns-3.45/utils/bench-scheduler.cc
--- ns-3.44/utils/bench-scheduler.cc	2025-03-09 16:55:49.823372800 -0700
+++ ns-3.45/utils/bench-scheduler.cc	2025-06-01 20:34:45.652702300 -0700
@@ -116,8 +116,7 @@
     uint64_t m_population;            /**< Event population size. */
     uint64_t m_total;                 /**< Total number of events to execute. */
     uint64_t m_count;                 /**< Count of events executed so far. */
-
-}; // class Bench
+};
 
 Bench::Result
 Bench::Run()
@@ -294,8 +293,7 @@
     }
 
     Simulator::Destroy();
-
-} // BenchSuite::Run
+}
 
 void
 BenchSuite::Header() const
@@ -373,8 +371,7 @@
     stdev.Log("stdev");
 
     LOG("");
-
-} // BenchSuite::Log()
+}
 
 /**
  *  Create a RandomVariableStream to generate next event delays.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/utils/check-style-clang-format.py ns-3.45/utils/check-style-clang-format.py
--- ns-3.44/utils/check-style-clang-format.py	2025-03-09 16:55:49.823372800 -0700
+++ ns-3.45/utils/check-style-clang-format.py	2025-06-01 20:34:45.653702300 -0700
@@ -41,7 +41,7 @@
 ###########################################################
 # PARAMETERS
 ###########################################################
-CLANG_FORMAT_MAX_VERSION = 17
+CLANG_FORMAT_MAX_VERSION = 19
 CLANG_FORMAT_MIN_VERSION = 15
 
 FORMAT_GUARD_ON = [
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/utils/create-module.py ns-3.45/utils/create-module.py
--- ns-3.44/utils/create-module.py	2025-03-09 16:55:49.823372800 -0700
+++ ns-3.45/utils/create-module.py	2025-06-01 20:34:45.653702300 -0700
@@ -230,103 +230,105 @@
 
 
 DOC_RST_TEMPLATE = """Example Module Documentation
-----------------------------
+============================
 
 .. include:: replace.txt
 .. highlight:: cpp
 
 .. heading hierarchy:
-   ------------- Chapter
-   ************* Section (#.#)
-   ============= Subsection (#.#.#)
-   ############# Paragraph (no number)
-
-This is a suggested outline for adding new module documentation to |ns3|.
-See ``src/click/doc/click.rst`` for an example.
-
-The introductory paragraph is for describing what this code is trying to
-model.
+   ============= Module Name
+   ------------- Section (#.#)
+   ~~~~~~~~~~~~~ Subsection (#.#.#)
+
+This is the outline for adding new module documentation to |ns3|.
+See ``src/lr-wpan/doc/lr-wpan.rst`` for an example.
+
+This first part is for describing what the model is trying to
+accomplish. General descriptions and design, overview of the project
+goes in this part without the need of any subsections. A visual summary
+is also recommended.
 
 For consistency (italicized formatting), please use |ns3| to refer to
 ns-3 in the documentation (and likewise, |ns2| for ns-2).  These macros
 are defined in the file ``replace.txt``.
 
-Model Description
-*****************
-
-The source code for the new module lives in the directory ``{MODULE_DIR}``.
+Detailed |ns3| Sphinx documentation guidelines can be found `here <https://www.nsnam.org/docs/contributing/html/models.html>`_
 
-Add here a basic description of what is being modeled.
 
-Design
-======
+The source code for the new module lives in the directory ``{MODULE_DIR}``.
 
-Briefly describe the software design of the model and how it fits into
-the existing ns-3 architecture.
 
 Scope and Limitations
-=====================
+---------------------
 
-What can the model do?  What can it not do?  Please use this section to
-describe the scope and limitations of the model.
+This is should be your first section. Please use it to list the scope and
+limitations. What can the model do?  What can it not do? Be brief and concise.
 
-References
-==========
+Section A
+---------
 
-Add academic citations here, such as if you published a paper on this
-model, or if readers should read a particular specification or other work.
+Free form. Your second section of your documentation and its subsections goes here.
+The documentation can contain any number of sections but be careful to not use
+more than two levels in subsections.
 
-Usage
-*****
+Section B
+---------
 
-This section is principally concerned with the usage of your model, using
-the public API.  Focus first on most common usage patterns, then go
-into more advanced topics.
+Free form. The last section of your documentation with content goes here.
 
-Building New Module
-===================
+Usage
+-----
 
-Include this subsection only if there are special build instructions or
-platform limitations.
+A brief description of the module usage goes here. This section must be present.
 
 Helpers
-=======
+~~~~~~~
 
-What helper API will users typically use?  Describe it here.
+A subsection with a description of the helpers used by the model goes here. Snippets of code are
+preferable when describing the helpers usage. This subsection must be present.
+If the model CANNOT provide helpers write "Not applicable".
 
 Attributes
-==========
+~~~~~~~~~~
 
-What classes hold attributes, and what are the key ones worth mentioning?
+A subsection with a list of attributes used by the module, each attribute should include a small
+description. This subsection must be present.
+If the model CANNOT provide attributes write "Not applicable".
 
-Output
-======
+Traces
+~~~~~~
 
-What kind of data does the model generate?  What are the key trace
-sources?   What kind of logging output can be enabled?
+A subsection with a list of the source traces used by the module, each trace should include a small
+description. This subsection must be present.
+If the model CANNOT provide traces write "Not applicable".
 
-Advanced Usage
-==============
+Examples and Tests
+------------------
 
-Go into further details (such as using the API outside of the helpers)
-in additional sections, as needed.
+A brief description of each example and test present in the model must be here.
+Include both the name of the example file and a brief description of the example.
+This section must be present.
 
-Examples
-========
+Validation
+----------
 
-What examples using this new code are available?  Describe them here.
+Describe how the model has been tested/validated.  What tests run in the
+test suite?  How much API and code is covered by the tests?
 
-Troubleshooting
-===============
+This section must be present. Write ``No formal validation has been made`` if your
+model do not contain validations.
 
-Add any tips for avoiding pitfalls, etc.
+References
+----------
 
-Validation
-**********
+The reference material used in the construction of the model.
+This section must be the last section and must be present.
+Use numbers for the index not names when listing the references. When possible, include the link of the referenced material.
+
+Example:
+
+[`1 <https://ieeexplore.ieee.org/document/6012487>`_] IEEE Standard for Local and metropolitan area networks--Part 15.4: Low-Rate Wireless Personal Area Networks (LR-WPANs)," in IEEE Std 802.15.4-2011 (Revision of IEEE Std 802.15.4-2006) , vol., no., pp.1-314, 5 Sept. 2011, doi: 10.1109/IEEESTD.2011.6012487.
 
-Describe how the model has been tested/validated.  What tests run in the
-test suite?  How much API and code is covered by the tests?  Again,
-references to outside published work may help here.
 """
 
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/utils/print-introspected-doxygen.cc ns-3.45/utils/print-introspected-doxygen.cc
--- ns-3.44/utils/print-introspected-doxygen.cc	2025-03-09 16:55:49.823372800 -0700
+++ ns-3.45/utils/print-introspected-doxygen.cc	2025-06-01 20:34:45.653702300 -0700
@@ -313,7 +313,8 @@
      */
     mutable std::vector<std::string> m_noTids;
 
-}; // class StaticInformation
+    // end of class StaticInformation
+};
 
 void
 StaticInformation::RecordAggregationInfo(std::string a, std::string b)
@@ -881,8 +882,7 @@
             PrintAttributesTid(os, tmp);
         }
         tmp = tmp.GetParent();
-
-    } // Attributes
+    }
 } // PrintAttributes()
 
 /**
@@ -1034,8 +1034,7 @@
         // Get the class's index out of the map;
         TypeId tid = TypeId::GetRegistered(item.second);
         PrintTypeIdBlock(os, tid);
-    } // for class documentation
-
+    }
 } // PrintTypeIdBlocks()
 
 /***************************************************************
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/VERSION ns-3.45/VERSION
--- ns-3.44/VERSION	2025-03-09 16:56:09.315445400 -0700
+++ ns-3.45/VERSION	2025-06-01 20:35:04.008764000 -0700
@@ -1 +1 @@
-3.44
+3.45
